#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glut.h>

#include <cv.h>
#include <highgui.h>
#include <math.h>

#include "defs.h"

#define LBUTTON 	0
#define MBUTTON 	1
#define RBUTTON 	2

#define PI 3.1459

typedef struct _opengl opengl_t;
typedef struct _angle angle_t;
typedef struct _mouse mouse_t;
typedef enum _state state_t;


enum _state
{
	pushed,
	released
};

struct _mouse
{
	state_t state;		
};

struct _angle
{
	double rx,ry,tz;
};

struct _opengl
{
	int width,height,posx,posy;
	int handle;
	char title[32];
	mouse_t mbutton[3];
	pt3d_t eye,center,up;
	pt2d_t mcoord;
	angle_t angle;
	void (*gl_keyboard)(unsigned char key, int x, int y);
	void (*gl_keyboardspe)(int key, int x, int y);
	void (*gl_mouse)(int button, int state,int x, int y);
	void (*gl_mousemove)(int x, int y);
	void (*gl_display)(void);
	void (*gl_reshape)(GLsizei w, GLsizei h);
	void (*gl_idle)(void);
};

void init_glwin(opengl_t glwin);

void DrawGrille(void);
void DrawAxe(void);
void PosEye(angle_t angle,pt3d_t *pt3d);

void initGL(int argc, char** argv);
void loopGL();
